/* tslint:disable */
/* eslint-disable */
/* prettier-ignore */
// This document is generated by rokot-apicontroller-client-generator. DO NOT edit directly.

export interface HeaderMap {
    [k: string]: string;
}

export interface IFetcher {
    request<T>(url: string, verb: string, contentType: string, body?: any, headers?: HeaderMap): Promise<T>;
    buildQueryString(query?: any): string;
    requestValidate?(routeUniqueName: string, paramValues: {
        body?: any;
        params?: any;
        query?: any;
    }): Promise<void>;
}

export class StringClass {
    property: string;
}

export class TestController {
    constructor(private fetcher: IFetcher) { }
    delete = (query?: StringClass, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`/delete${this.fetcher.buildQueryString(query)}`, "delete", "application/json", undefined, headers);
    };
    get = (query?: StringClass, headers?: HeaderMap): Promise<void> => {
        return this.fetcher.request<void>(`/get${this.fetcher.buildQueryString(query)}`, "get", "application/json", undefined, headers);
    };
}

export class ApiClient {
    constructor(private fetcher: IFetcher) { }
    test = new TestController(this.fetcher);
}